using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using WiimoteLib;

namespace WiiIR
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //Nintendo Wii 
        Wiimote wm;
        WiimoteState ws;

        Texture2D crosshair;
        float aimX, aimY;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            wm = new Wiimote();

            //Bind events
            wm.WiimoteChanged += new WiimoteChangedEventHandler(wm_OnWiimoteChanged);
            wm.WiimoteExtensionChanged += new WiimoteExtensionChangedEventHandler(wm_OnWiimoteExtensionChanged);

            // koppla upp mot wii-kontrollen
            wm.Connect();

            // stll in s att information om IR och acceleration skickas
            // annars skiackas bara information om knapparna
            wm.SetReportType(Wiimote.InputReport.IRAccel, true);
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            crosshair = Content.Load<Texture2D>("crosshair");
        }

        protected override void UnloadContent()
        {
        }

        protected override void Update(GameTime gameTime)
        {

            aimX = 800 - ws.IRState.MidX * 800;
            aimY = ws.IRState.MidY * 600;

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            Vector2 origin = new Vector2(crosshair.Width / 2, crosshair.Height / 2);
            spriteBatch.Draw(crosshair, new Vector2((float)aimX, (float)aimY), null, Color.White, 0, origin, 1, SpriteEffects.None, 0);
            spriteBatch.End();

            base.Draw(gameTime);
        }

        void wm_OnWiimoteExtensionChanged(object sender, WiimoteExtensionChangedEventArgs args)
        {
            if (args.Inserted)
                wm.SetReportType(Wiimote.InputReport.IRExtensionAccel, true);    // return extension data
            else
                wm.SetReportType(Wiimote.InputReport.IRAccel, true);            // back to original mode
        }

        void wm_OnWiimoteChanged(object sender, WiimoteChangedEventArgs args)
        {
            // nuvarande information frn kontrollen
            ws = args.WiimoteState;

        }
    }
}
